<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00006000RelacServicoFactory;
use Teknisa\Libs\Util\Environment;

class Sm00006000RelacServicoService
{
    
    protected $RelacServicoFactory;
    protected $Environment;
    
    public function __construct (Sm00006000RelacServicoFactory $RelacServicoFactory, Environment $Environment){
        
        $this->RelacServicoFactory  = $RelacServicoFactory;
        $this->Environment  = $Environment;

    }
    
    /**
     * A função "validaServicoRelacionado" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço.
     */
     
    public function validaServicoRelacionado($servOrcaRelac, $servOrca, $tipoMedida){
    
        $paramsValidaServRelac = array(
            "CDSERVORCARELAC"  => implode(',', $servOrcaRelac),
            "CDSERVORCA"       => $servOrca,
            "CDTPMEDIDASERV"   => $tipoMedida,
            "NRORG"            => $this->Environment->getNrOrg()
        );
        
        $returnValidaServRelac = $this->RelacServicoFactory->validaServicoRelacionado($paramsValidaServRelac);
        
        return $returnValidaServRelac[0]["VALIDASERV"] != 0;
        
    }


    /**
     * A função "validaServicoRelacionadoUnit" verifica se o serviço 
     * que está sendo relacionado já existe está relacionadoao serviço para inclusão 
     * de um só item.
     */
     
    public function validaServicoRelacionadoUnit($servOrcaRelac, $servOrca, $tipoMedida) {
        $paramsValidaServRelac = array(
            "CDSERVORCARELAC"  => $servOrcaRelac,
            "CDSERVORCA"       => $servOrca,
            "NRORG"            => $this->Environment->getNrOrg()
        );
        
        $returnValidaServRelac = $this->RelacServicoFactory->validaServicoRelacionadoUnit($paramsValidaServRelac);
        return $returnValidaServRelac[0]["VALIDASERV"] != 0;
    }
    
    /**
     * Replica o valor do parametro de fixação da medida para todos os elementos da árvore
    **/
    public function replicarAlteracaoMedidaServ($idElemento, $idMedida, $nrorg, $servrelac){
        $params = array(
            "IDELEMENTO"      => $idElemento,
            "NRORG"           => $nrorg,
            "IDMEDIDAFIXA"    => $idMedida,
            "CDSERVORCARELAC" => $servrelac
        );
        
        $this->RelacServicoFactory->replicarAlteracaoMedidaServ($params);
    }
    /**
     * Retorna o nome dos serviços passados como parametro
    **/
    public function getNameServorca($cdservorca, $nrorg) {
        $cdservorca = implode(",", $cdservorca);
        $dataset    = $this->RelacServicoFactory->getNameServorca($cdservorca, $nrorg);
        return $dataset[0]["NMSERVORCA"];
    }
}
?>