<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctGerarParcelasFatura {
    
    const NOME = "FCT_GERAR_PARCELAS_FATURA_2";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqcontrato
     * @param integer $nrorg
     * @param string $operador
     * @param integer $idRenovacao - ID se o contrato esta sendo renovado: 0 = false, 1 = true
     * 
     * @return string
     */
    public function executar($nrseqcontrato, $nrorg, $operador, $idRenovacao = 0) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQCONTRATO",  Param::PARAM_INPUT,  $nrseqcontrato,   Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRORG",          Param::PARAM_INPUT,  $nrorg,           Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_CDOPERADOR",     Param::PARAM_INPUT,  $operador,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_IDRENOVACAO",    Param::PARAM_INPUT,  $idRenovacao,     Param::PARAM_TYPE_INT));
        
        $procedure->execute();
    }
    
}

?>